-- updated gatherer addon

--[==[

/etrace
/fstack

the purpose of this addon is to re make the gatherer addon for the new bfa API

]==]--

local name, Forager = ...

--Forager = {}

Forager.MapNodeCache = {}

Forager.MainFrame = CreateFrame('FRAME', nil, UIParent)

Forager.MainFrame:RegisterEvent('UNIT_SPELLCAST_SENT')
Forager.MainFrame:RegisterEvent('CHAT_MSG_LOOT')
Forager.MainFrame:RegisterEvent('ADDON_LOADED')
Forager.MainFrame:RegisterEvent('QUEST_LOG_UPDATE')


Forager.CurrentMapID = nil;
Forager.CurrentMapPosition = nil;
Forager.CurrentMapName = nil;

Forager.WorldMapZoneDisplayed = nil;
Forager.IsZoneDisplayedInZoneTable = false; --current world map display, does the db have any entries for that zone

Forager.GatherSpellRange = 0.0065 --this is roughly double the mining spell range HOWEVER this may need checking with time and adjusting, the idea being we can find a matching node even if player stands on opposites sides.

Forager.IsForagingSpellCast = false --was last cast a loot node spell
Forager.NodeUpdated = false
Forager.LootUpdated = false
Forager.LastLootSpell = nil; -- mining or herbs
Forager.ForagingTarget = nil; -- what was spell cast at (vein, herb)

----------------------------------------------------------
-- old variables no longer used, except distance checking
----------------------------------------------------------
Forager.OldCurrentMapID = nil;
Forager.OldCurrentMapPosition = nil;
Forager.OldCurrentMapName = nil;


-----------------------------------------------------------------------------------------------------------------------------------
-- WORLD MAP TOOLTIP
-----------------------------------------------------------------------------------------------------------------------------------
Forager.NodeToolTip = CreateFrame('FRAME', 'ForagerNodeToolTip', UIParent)
Forager.NodeToolTip:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
												edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
												tile = true, tileSize = 16, edgeSize = 16, 
												insets = { left = 4, right = 4, top = 4, bottom = 4 }});
Forager.NodeToolTip:SetBackdropColor(0, 0, 0, 0.7)
Forager.NodeToolTip:SetSize(250, 50)
Forager.NodeToolTip:SetFrameLevel(4)
Forager.NodeToolTip:SetFrameStrata('HIGH')
ForagerNodeToolTip:Hide()

Forager.NodeToolTip.DateText = Forager.NodeToolTip:CreateFontString(nil, "OVERLAY", "GameFontNormal")
Forager.NodeToolTip.DateText:SetPoint('TOPLEFT', 8, -8)
Forager.NodeToolTip.DateText:SetText('Foraged')

Forager.NodeToolTip.DateTextValue = Forager.NodeToolTip:CreateFontString(nil, "OVERLAY", "GameFontNormal")
Forager.NodeToolTip.DateTextValue:SetPoint('TOP', 0, -8)

Forager.NodeToolTip.TimeTextValue = Forager.NodeToolTip:CreateFontString(nil, "OVERLAY", "GameFontNormal")
Forager.NodeToolTip.TimeTextValue:SetPoint('TOPRIGHT', -8, -8)

Forager.NodeToolTip.RightHeader = Forager.NodeToolTip:CreateFontString(nil, "OVERLAY", "GameFontNormal")
Forager.NodeToolTip.RightHeader:SetPoint('TOPRIGHT', -8, -22)
Forager.NodeToolTip.RightHeader:SetText('Average')

Forager.NodeToolTip.InfoTextLeft = {}
for i = 1, 10 do
	Forager.NodeToolTip.InfoTextLeft[i] = Forager.NodeToolTip:CreateFontString('ForagerNodeToolTipTextLeft'..i, "OVERLAY", "GameFontNormal")
	Forager.NodeToolTip.InfoTextLeft[i]:SetPoint('TOPLEFT', 8, ((i * -22) - 22))
end

Forager.NodeToolTip.InfoTextRight = {}
for i = 1, 10 do
	Forager.NodeToolTip.InfoTextRight[i] = Forager.NodeToolTip:CreateFontString('ForagerNodeToolTipTextRight'..i, "OVERLAY", "GameFontNormal")
	Forager.NodeToolTip.InfoTextRight[i]:SetPoint('TOPRIGHT', -30, ((i * -22) - 22))
end

-----------------------------------------------------------------------------------------------------------------------------------
-- SLASH COMMANDS
-----------------------------------------------------------------------------------------------------------------------------------
SLASH_FORAGER1 = '/forager'
SlashCmdList['FORAGER'] = function(msg)
	if msg == 'pos check' then --print current position and distance to last position if exist
		Forager.OldCurrentMapPosition = Forager.CurrentMapPosition		
		Forager.CurrentMapID = C_Map.GetBestMapForUnit('player')
		Forager.CurrentMapPosition = C_Map.GetPlayerMapPosition(Forager.CurrentMapID, 'player')
		print('location', Forager.CurrentMapPosition.x, Forager.CurrentMapPosition.y, C_Map.GetMapInfo(Forager.CurrentMapID).name)		
		if Forager.OldCurrentMapPosition ~= nil then 
			local x_dis = (Forager.OldCurrentMapPosition.x - Forager.CurrentMapPosition.x)
			local y_dis = (Forager.OldCurrentMapPosition.y - Forager.CurrentMapPosition.y)			
			local dis = (((x_dis * x_dis) + (y_dis * y_dis)) ^ 0.5)			
			print('Distance', dis)		
		end
		
	elseif msg == 'map zone db check' then -- is this zone in db
		local zone = WorldMapFrame:GetMapID()		
		for k, z in ipairs(Forager.MapZoneTable) do
			if z.Name == C_Map.GetMapInfo(zone).name then
				print('This is a zone in the db')
			end
		end
		
	end
end

-----------------------------------------------------------------------------------------------------------------------------------
-- FUNCTIONS
-----------------------------------------------------------------------------------------------------------------------------------
function Forager.DrawFrame(parent, name, x, y, w, h, r, g, b, a)
	local f = CreateFrame('FRAME', name, parent)
	f:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
												edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
												tile = true, tileSize = 16, edgeSize = 16, 
												insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	f:SetBackdropColor(r, g, b, a)
	f:SetSize(w, h)
	f:SetPoint('BOTTOMLEFT', x, y)
end

function Forager.ClearToolTipText()
	for i = 1, 10 do
		Forager.NodeToolTip.InfoTextLeft[i]:SetText(' ')
		Forager.NodeToolTip.InfoTextLeft[i]:SetText(nil)
		
		Forager.NodeToolTip.InfoTextRight[i]:SetText(' ')
		Forager.NodeToolTip.InfoTextRight[i]:SetText(nil)
	end

end

function Forager.HideForagerToolTip()
	--reposition to bottomleft -> to be done ????
	ForagerNodeToolTip:Hide()
end

function Forager.DrawMapNodeIcon(f, x, y, w, h, level, strata, icon)

	f:SetPoint("TOPLEFT", x, (y * -1)) -- convert Y axis to negative number to draw pin from top left anchor
	f:SetSize(w, h)
	f:SetFrameLevel(level)
	f:SetFrameStrata(strata)
	f:EnableKeyboard(true)
	f:SetPropagateKeyboardInput(true)
	
	--f:SetScript('OnEnter', Forager.ShowForagerToolTip) -- set in the CreateFrame during event
	f:SetScript('OnLeave', Forager.HideForagerToolTip)
	
	f.texture = f:CreateTexture(nil, 'ARTWORK')
	f.texture:SetAllPoints(f)
	f.texture:SetTexture(icon)
end

--print event args to chat window
function getArgs(...)
	for i=1, select("#", ...) do
		arg = select(i, ...)
		print(i.." "..tostring(arg))
	end
end

--find the item id from the hyperlink string
function Forager.ItemIDFromLootString(str)
	local s = string.find(str, 'Hitem:')
	local t = string.sub(str, s + 6)
	local f = string.find(t, ':')
	local n = string.sub(t, 1, f - 1)
	--print(n)
	return n
end

function Forager.ItemLootCountFromString(str)
	local s = string.find(str, '|r')
	--print('|r is at', s, 'length is', string.len(str))
	local c = string.sub(str, s + 1)
	--print(c)
	if string.find(c, 'x') then
		return tonumber(string.sub(str, s + 3, string.len(str)-1)) --ignore full stop '.' at end
	else
		return 1 -- return 1 if no 'x?' in string
	end
end

function Forager.PrintColourMessage(colour, msg)
	print(colour..'Forager: '..msg..'|r')
end

--check node coords with current coords, if within double spell range then assume same node (not often to find 2 nodes together and if player does then loot info will be combined)
function Forager.IsNodeInRange(myPosX, myPosY, nodePosX, nodePosY)
	local distance = ((((myPosX - nodePosX)^2) + ((myPosY - nodePosY)^2)) ^ 0.5)
	if distance < Forager.GatherSpellRange then
		return true
	else
		return false
	end
end


function Forager.UpdateMapPins()

	Forager.IsZoneDisplayedInZoneTable = false

	--get the current map zone displayed in world map and check if its a zone in the db
	for k, zone in ipairs(Forager.MapZoneTable) do
		if zone.Name == C_Map.GetMapInfo(WorldMapFrame:GetMapID()).name then
			Forager.IsZoneDisplayedInZoneTable = true
			Forager.CurrentMapID = WorldMapFrame:GetMapID()
		end
	end
	
	for k, p in ipairs(Forager.MapNodeCache) do 
		p:Hide()
	end
	
	--if zone exist in zone db and node db has entries for zone
	if Forager.IsZoneDisplayedInZoneTable == true and ForagerGlobalSettings.NodesLootedDatabase[C_Map.GetMapInfo(Forager.CurrentMapID).name] ~= nil then
		local MapWidth = WorldMapFrame.ScrollContainer.Child:GetWidth()
		local MapHeight = WorldMapFrame.ScrollContainer.Child:GetHeight()
		
		for k, node in ipairs(ForagerGlobalSettings.NodesLootedDatabase[C_Map.GetMapInfo(Forager.CurrentMapID).name]) do
						
			local icon = GetItemIcon(node.LootTable[1].ID)
			
			if Forager.MapNodeCache[k] == nil then
				--no pin in cache, create frame for pin and pass to drawing function
				local Pin = CreateFrame('FRAME', 'ForagerMapNodePin'..k, WorldMapFrame.ScrollContainer.Child)
				Forager.DrawMapNodeIcon(Pin, (node.PosX * MapWidth), (node.PosY * MapHeight), 12, 12, 4, 'HIGH', icon)
				Forager.MapNodeCache[k] = Pin
				--add onenter script
				Pin:SetScript('OnEnter', function() 
					Forager.ClearToolTipText()
					Forager.NodeToolTip.DateTextValue:SetText(node.VisitDate.day..'/'..node.VisitDate.month..'/'..node.VisitDate.year)
					Forager.NodeToolTip.TimeTextValue:SetText(node.VisitDate.hour..':'..node.VisitDate.min..':'..node.VisitDate.sec)
					for k, loot in ipairs(node.LootTable) do 
						--print(k, loot.Link)
						Forager.NodeToolTip.InfoTextLeft[k]:SetText(loot.Link)
						--Forager.NodeToolTip.InfoTextMiddle[k]:SetText(loot.Link)
						Forager.NodeToolTip.InfoTextRight[k]:SetText(loot.LootCount / loot.VisitCount)
						Forager.NodeToolTip:SetSize(250, ((k * 22) + 50))
					end
					local x, y = GetCursorPosition()
					local s = UIParent:GetEffectiveScale()
					ForagerNodeToolTip:ClearAllPoints()
					ForagerNodeToolTip:SetPoint("BOTTOMLEFT", ((x/s) + 50), ((y/s) - Forager.NodeToolTip:GetHeight()))
					ForagerNodeToolTip:Show()
				end)
				
			else
				-- re use existing frame for pin
				Forager.MapNodeCache[k]:SetPoint("TOPLEFT", (node.PosX * MapWidth), ((node.PosY * MapHeight) * -1))
				Forager.MapNodeCache[k].texture:SetTexture(icon)
				Forager.MapNodeCache[k]:Show()
				Forager.MapNodeCache[k]:SetScript('OnEnter', function() 
					Forager.ClearToolTipText()
					Forager.NodeToolTip.DateTextValue:SetText(node.VisitDate.day..'/'..node.VisitDate.month..'/'..node.VisitDate.year)
					Forager.NodeToolTip.TimeTextValue:SetText(node.VisitDate.hour..':'..node.VisitDate.min..':'..node.VisitDate.sec)
					for k, loot in ipairs(node.LootTable) do 
						--print(k, loot.Link)
						Forager.NodeToolTip.InfoTextLeft[k]:SetText(loot.Link)
						
						Forager.NodeToolTip.InfoTextRight[k]:SetText(loot.LootCount / loot.VisitCount)
						Forager.NodeToolTip:SetSize(250, ((k * 22) + 50))
					end
					local x, y = GetCursorPosition()
					local s = UIParent:GetEffectiveScale()
					ForagerNodeToolTip:ClearAllPoints()
					ForagerNodeToolTip:SetPoint("BOTTOMLEFT", ((x/s) + 50), ((y/s) - Forager.NodeToolTip:GetHeight()))
					ForagerNodeToolTip:Show()
				end)
			
			end
		end
	end
end

function Forager.OnEvent(self, event, ...)

	if event == 'UNIT_SPELLCAST_SENT' then
		-- left as seperate if checks for ease of reading and updating with new foraging spells or nodes
		if select(4, ...) == 265837 then -- mining
			Forager.LastLootSpell = 265837
			Forager.IsForagingSpellCast = true
			Forager.ForagingTarget = select(2, ...)
		elseif select(4, ...) == 265819 then --herbs
			Forager.LastLootSpell = 265819
			Forager.IsForagingSpellCast = true
			Forager.ForagingTarget = select(2, ...)
		else
			Forager.LastLootSpell = nil
			Forager	.IsForagingSpellCast = false
			Forager.ForagingTarget = nil;
		end
	end
	
	if event == 'QUEST_LOG_UPDATE' then
		if WorldMapFrame:IsVisible() == true then
			Forager.UpdateMapPins()
		end
	end
		
	if event == 'CHAT_MSG_LOOT' and Forager.IsForagingSpellCast == true then
		--grab current position
		Forager.CurrentMapID = C_Map.GetBestMapForUnit('player')
		Forager.CurrentMapPosition = C_Map.GetPlayerMapPosition(Forager.CurrentMapID, 'player')
		Forager.CurrentMapName = C_Map.GetMapInfo(Forager.CurrentMapID).name
		
		--check if a table exist for this map zone
		if ForagerGlobalSettings.NodesLootedDatabase[Forager.CurrentMapName] == nil then
			ForagerGlobalSettings.NodesLootedDatabase[Forager.CurrentMapName] = {}
		end
		
		--variables just for ease of reading
		local LootItemID = Forager.ItemIDFromLootString(select(1, ...))
		local LootItemCount = Forager.ItemLootCountFromString(select(1, ...))
		
		--reset the bool check
		Forager.NodeUpdated = false
		Forager.LootUpdated = false
		
		--check we have coords
		if Forager.CurrentMapPosition ~= nil then
			--search db and add or updated
			if ForagerGlobalSettings.NodesLootedDatabase[Forager.CurrentMapName] ~= nil then
				for k, node in ipairs(ForagerGlobalSettings.NodesLootedDatabase[Forager.CurrentMapName]) do
					--check if we have been at this node before
					if Forager.IsNodeInRange(Forager.CurrentMapPosition.x, Forager.CurrentMapPosition.y, node.PosX, node.PosY) then
						Forager.PrintColourMessage('|cff628B57', 'Found node in database, updating loot table')
						--loop loot table and check against ID
						for k, l in ipairs(node.LootTable) do
							--matching item so update count
							if l.ID == LootItemID then
								l.LootCount = l.LootCount + LootItemCount
								l.VisitCount = l.VisitCount + 1
								--change bool check
								Forager.LootUpdated = true
							end
						end
						--if loot item doesn't exist we add to table
						if Forager.LootUpdated == false then
							local NewLoot = { ID = LootItemID, Link = select(2, GetItemInfo(LootItemID)), LootCount = LootItemCount, VisitCount = 1 }
							table.insert(node.LootTable, NewLoot)
						end
						node.VisitDate = date('*t')
						--if node has been updated change bool check
						Forager.NodeUpdated = true
					end
				end
			end
			
			--if node wasn't updated then we add a new entry
			if Forager.NodeUpdated == false then
				Forager.PrintColourMessage('|cff628B57', 'Node not found, adding new entry')
				local node = { GUID = UnitGUID('player'), Target = Forager.ForagingTarget, LootSpell = Forager.LastLootSpell, LootTable = {}, MapName = Forager.CurrentMapName, MapID = Forager.CurrentMapID, PosX = Forager.CurrentMapPosition.x, PosY = Forager.CurrentMapPosition.y, VisitDate = date('*t') }
				--first entry of node has empty loot table so we can use t[1]
				node.LootTable[1] = { ID = LootItemID, Link = select(2, GetItemInfo(LootItemID)), LootCount = LootItemCount, VisitCount = 1 }
				table.insert(ForagerGlobalSettings.NodesLootedDatabase[Forager.CurrentMapName], node)
			end
		end

	end
	
	
	if event == 'ADDON_LOADED' and select(1, ...) == 'Forager' then
		if ForagerGlobalSettings == nil then
			ForagerGlobalSettings = { AddonName = 'Forager', NodesLootedDatabase = {}}
		end
		Forager.PrintColourMessage('|cff628B57', 'Forager Loaded')
	end

end

Forager.MainFrame:SetScript('OnEvent', Forager.OnEvent)